import { BigNumber } from 'ethers';
export declare namespace SpreadMatcher {
    interface Entity {
        id: string;
        volume: BigNumber;
    }
    interface Params<T extends Entity, P extends Entity> {
        groupPriority: {
            id: string;
            groupPriority: {
                id: string;
            }[][];
        }[][];
        entityGroups: [T[], P[]];
    }
    interface Match<T extends Entity, P extends Entity> {
        entities: [Omit<T, 'volume'>, Omit<P, 'volume'>];
        volume: BigNumber;
    }
    interface Result<T extends Entity, P extends Entity> {
        matches: Match<T, P>[];
        leftoverEntities: [T[], P[]];
    }
    const spreadMatcher: <T extends Entity, P extends Entity>(originalData: Params<T, P>) => Result<T, P>;
}
