"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MatchResultPostgresRepository = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const typeorm_2 = require("typeorm");
const MatchResult_entity_1 = require("./MatchResult.entity");
const MatchResult_repository_1 = require("./MatchResult.repository");
let MatchResultPostgresRepository = class MatchResultPostgresRepository {
    constructor(repository, connection) {
        this.repository = repository;
        this.connection = connection;
    }
    async create(matchResult) {
        return await this.repository.save(matchResult);
    }
    async getAll() {
        return await this.repository.find();
    }
    async find(findOptions) {
        return await this.repository.find({
            where: {
                consumerId: typeorm_2.In(findOptions.consumerIds),
                generatorId: typeorm_2.In(findOptions.generatorIds),
                timestamp: typeorm_2.Between(findOptions.from, findOptions.to)
            }
        });
    }
    async findGrouped(findOptions, groupOptions) {
        const sanitized = this.sanitizeInput(groupOptions);
        const queryRunner = this.connection.createQueryRunner();
        const matchResultQuery = this.connection
            .createQueryBuilder()
            .select(sanitized)
            .addSelect(`array_agg(row_to_json(${MatchResult_entity_1.tableName})) as entries`)
            .from(MatchResult_entity_1.tableName, MatchResult_entity_1.tableName)
            .where(`"${MatchResult_repository_1.MatchResultColumns.ConsumerId}" IN (${this.sanitizeInput(findOptions.consumerIds, "'").join(', ')})`)
            .andWhere(`"${MatchResult_repository_1.MatchResultColumns.GeneratorId}" IN (${this.sanitizeInput(findOptions.generatorIds, "'").join(', ')})`)
            .andWhere(`"${MatchResult_repository_1.MatchResultColumns.Timestamp}" between :dateFrom and :dateTo`, {
            dateFrom: findOptions.from,
            dateTo: findOptions.to
        })
            .groupBy(sanitized.join(', '))
            .getQueryAndParameters();
        const res = await queryRunner.query(matchResultQuery[0], matchResultQuery[1]);
        return res;
    }
    sanitizeInput(input, token) {
        const sanitizationToken = token ?? `"`;
        return input.map((i) => `${sanitizationToken}${i}${sanitizationToken}`);
    }
};
MatchResultPostgresRepository = __decorate([
    common_1.Injectable(),
    __param(0, typeorm_1.InjectRepository(MatchResult_entity_1.MatchResultEntity)),
    __param(1, typeorm_1.InjectConnection()),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        typeorm_2.Connection])
], MatchResultPostgresRepository);
exports.MatchResultPostgresRepository = MatchResultPostgresRepository;
//# sourceMappingURL=MatchResultPostgres.repository.js.map